// Luca Burger

import java.util.ArrayList;
import java.util.Date;

public abstract class Konto {
    protected String kontonummer;
    protected String kontobezeichnung;
    protected double saldo;
    private ArrayList<Transaktion> transaktionsverlauf = new ArrayList<Transaktion>();

    public Konto(String kontonummer, String kontobezeichnung) {
        this.kontonummer = kontonummer;
        this.kontobezeichnung = kontobezeichnung;
    }

    public String getKontonummer() {
        return kontonummer;
    }

    public String getKontobezeichnung() {
        return kontobezeichnung;
    }

    public double getSaldo() {
        return saldo;
    }

    public ArrayList<Transaktion> getTransaktionsverlauf() {
        return transaktionsverlauf;
    }

    public void transaktionDurchfuehren(double betrag, String beschreibung) {
        Transaktion transaktion = new Transaktion(new Date(), beschreibung, betrag);
        transaktionsverlauf.add(transaktion);
    }

    protected abstract void buchen(double betrag);
}
